// Copyright (C) 2009-2011 Christian Stehno
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __E_RESOLUTION_CHOICE_H_INCLUDED__
#define __E_RESOLUTION_CHOICE_H_INCLUDED__

#include <iostream>
#include <irrlicht.h>

namespace irr
{
// TODO
static core::dimension2du resolutionChoiceConsole(
                                                  IrrlichtDevice* device
                                                  )
{
    _IRR_DEBUG_BREAK_IF(device == 0);

    video::IVideoModeList* videoModes = device->getVideoModeList();

    //WindowConfig.WindowSize
    core::dimension2du resolution(640,480) ;

//    struct SResolutionEntry
//    {
//        SResolutionEntry(const char* description, core::dimension2du resolution) :
//            Description(description)
//            , Resolution(resolution)
//        {
//        }
//        const char* Description;
//        core::dimension2du Resolution;
//    };

//	const int dims[] = {
//                1024,768,
//                1600,900,
//                640,480
////            //"Burning's Video","Direct3D 8.1","Direct3D 9.0c","OpenGL 1.x/2.x/3.x"
//                };

	printf("Please select the resolution you want:\n");


    //stringw currentMode = videoModeToText(driver->);
    /////////////////////////////////////////////////////////////////
    ///////     select current resolution
    /////////////////////////////////////////////////////////////////

    irr::u32 maxLength = 0;
    //engine->getFont()->getDimension();
    for(s32 i = 0; i < videoModes->getVideoModeCount(); ++i)
    {
        core::dimension2du dims = videoModes->getVideoModeResolution(i);
        printf("%c Resolution %d x %d x %d\n", 'a' + i, dims.Width, dims.Height, videoModes->getVideoModeDepth(i) );
    }


//    for(s32 i = 0; i < 3; i += 2)
//    {
//        //!dims
//        printf("%c Resolution %d x %d\n", 'a' + i, dims[i+0], dims[i+1]);
//    }

	char c;
	std::cin >> c;
    c = c - 'a';

    if(c < videoModes->getVideoModeCount())
    {
        printf("entry found");
        resolution = videoModes->getVideoModeResolution(c);
    }
//	c = irr::video::EDT_COUNT+'a'-c;
//
//	for (i=irr::video::EDT_COUNT; i>0; --i)
//	{
//		if (!(allDrivers || (irr::IrrlichtDevice::isDriverSupported(irr::video::E_DRIVER_TYPE(i-1)))))
//			--c;
//		if ((char)i==c)
//			return irr::video::E_DRIVER_TYPE(i-1);
//	}
//	return irr::video::EDT_COUNT;
//    return videoModes->getVideoModeResolution(c);
//    return core::dimension2du(640,480);
    return resolution;
}



} // end namespace irr

#endif
