#include "CSharedObjectWin32.h"
//#include <os.h>

#if defined(_IRR_COMPILE_WITH_WINDOWS_DEVICE_)



namespace irr
{

CSharedObjectWin32::CSharedObjectWin32() :
    m_Library(0)
{

}


CSharedObjectWin32::~CSharedObjectWin32()
{

}

bool CSharedObjectWin32::load(io::path filename)
{

    // TODO add .dll
    filename += ".dll";
    // Chargement de la bibliothèque dynamique
    m_Library = LoadLibrary( filename.c_str() );
    if (!m_Library)
    {
//        os::Printer::log("Can't load library", ELL_ERROR);
        return false;
    }


    return true;
}


void * CSharedObjectWin32::getSymbol(const core::stringc& name)
{
    //!
    return (void*)GetProcAddress(m_Library, name.c_str() );
//    void *Function = GetProcAddress(m_Library, name.c_str() );
//    if (!Function)
//        os::Printer::log("Can't find symbol", ELL_ERROR);
//    return Function;
}

//
//bool CSharedObjectWin32::load(const io::path& filename)
//{
//
//    // Chargement de la bibliothèque dynamique
//    = UnloadLibrary( m_Library  );
//    if (!m_Library)
//    {
//        os::Printer::log("Can't load library",ELL_ERROR);
//    }
//
//}



}


#endif // #if defined(_IRR_COMPILE_WITH_WINDOWS_DEVICE_)
