// Copyright (C) 2009-2011 Christian Stehno
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __CREATION_PARAMS_CHOICE_H_INCLUDED__
#define __CREATION_PARAMS_CHOICE_H_INCLUDED__

#include <iostream>
#include "IRenderWindow.h"
#include "IVideoContext.h"
//#include "EDriverTypes.h"


#define BOOLEAN_QUESTION(question,answer,value) \
    printf( question ); \
    while(1){ \
        std::cin >> answer; \
        if(answer == 'y') { value = true;break; } \
        else if( answer == 'n'){ value = false;break;} \
    }


namespace irr
{

//! ask user for driver
static
//irr::SIrrlichtCreationParameters
video::SRenderWindowConfig
chooseRenderWindowConfig()
{

    char c = 0;
    video::SRenderWindowConfig config;
//    SIrrlichtCreationParameters creationParams;
    BOOLEAN_QUESTION("Wanna go fullscreen (y/n)?",c, config.Fullscreen);

    if(!config.Fullscreen){
        BOOLEAN_QUESTION("Resizable Window (y/n)?",c, config.Resizable);
    }

    BOOLEAN_QUESTION("Enable vsync (y/n)?",c, config.Vsync);

    return config;
}


} // end namespace irr

#endif
