#include "CreateBurningVideoDriver.h"
#include "CSoftwareDriver2.h"

namespace irr
{
namespace video
{

#ifdef _IRR_COMPILE_WITH_BURNINGSVIDEO_
//! creates a video driver
IVideoDriver* createBurningVideoDriver( IrrlichtDevice* device )
{

	return new CBurningVideoDriver(
//                                params,
//                                io,
//                                presenter
                                device->getFileSystem(),
                                device->getImageManager()
                                );
//	#else
//	return 0;

}


#endif // _IRR_COMPILE_WITH_BURNINGSVIDEO_

}
}
